/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the ScPermissionCreateData type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ScPermissionCreateData{}

// ScPermissionCreateData struct for ScPermissionCreateData
type ScPermissionCreateData struct {
	Name string `json:"name"`
	MainRolloutId string `json:"main_rollout_id"`
	TermsContent string `json:"terms_content"`
	Active bool `json:"active"`
}

// NewScPermissionCreateData instantiates a new ScPermissionCreateData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewScPermissionCreateData(name string, mainRolloutId string, termsContent string, active bool) *ScPermissionCreateData {
	this := ScPermissionCreateData{}
	this.Name = name
	this.MainRolloutId = mainRolloutId
	this.TermsContent = termsContent
	this.Active = active
	return &this
}

// NewScPermissionCreateDataWithDefaults instantiates a new ScPermissionCreateData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewScPermissionCreateDataWithDefaults() *ScPermissionCreateData {
	this := ScPermissionCreateData{}
	return &this
}

// GetName returns the Name field value
func (o *ScPermissionCreateData) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *ScPermissionCreateData) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *ScPermissionCreateData) SetName(v string) {
	o.Name = v
}

// GetMainRolloutId returns the MainRolloutId field value
func (o *ScPermissionCreateData) GetMainRolloutId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.MainRolloutId
}

// GetMainRolloutIdOk returns a tuple with the MainRolloutId field value
// and a boolean to check if the value has been set.
func (o *ScPermissionCreateData) GetMainRolloutIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.MainRolloutId, true
}

// SetMainRolloutId sets field value
func (o *ScPermissionCreateData) SetMainRolloutId(v string) {
	o.MainRolloutId = v
}

// GetTermsContent returns the TermsContent field value
func (o *ScPermissionCreateData) GetTermsContent() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TermsContent
}

// GetTermsContentOk returns a tuple with the TermsContent field value
// and a boolean to check if the value has been set.
func (o *ScPermissionCreateData) GetTermsContentOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TermsContent, true
}

// SetTermsContent sets field value
func (o *ScPermissionCreateData) SetTermsContent(v string) {
	o.TermsContent = v
}

// GetActive returns the Active field value
func (o *ScPermissionCreateData) GetActive() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.Active
}

// GetActiveOk returns a tuple with the Active field value
// and a boolean to check if the value has been set.
func (o *ScPermissionCreateData) GetActiveOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Active, true
}

// SetActive sets field value
func (o *ScPermissionCreateData) SetActive(v bool) {
	o.Active = v
}

func (o ScPermissionCreateData) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ScPermissionCreateData) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["name"] = o.Name
	toSerialize["main_rollout_id"] = o.MainRolloutId
	toSerialize["terms_content"] = o.TermsContent
	toSerialize["active"] = o.Active
	return toSerialize, nil
}

type NullableScPermissionCreateData struct {
	value *ScPermissionCreateData
	isSet bool
}

func (v NullableScPermissionCreateData) Get() *ScPermissionCreateData {
	return v.value
}

func (v *NullableScPermissionCreateData) Set(val *ScPermissionCreateData) {
	v.value = val
	v.isSet = true
}

func (v NullableScPermissionCreateData) IsSet() bool {
	return v.isSet
}

func (v *NullableScPermissionCreateData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableScPermissionCreateData(val *ScPermissionCreateData) *NullableScPermissionCreateData {
	return &NullableScPermissionCreateData{value: val, isSet: true}
}

func (v NullableScPermissionCreateData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableScPermissionCreateData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


